if ( rawget(_G,"pypak_lua_registered") ) then 
	print("[PyPak] Found existing definition, latching onto it")
	return 
end

rawset(_G,"pypak_lua_registered",true)

-- actual code time now

local pypak = {}

-- voiceline defs

pypak.voices = {
	ena = {
		victory = { "sfx_enaaw2", "sfx_enaaw3", "sfx_enaaw4", "sfx_enaaw5", "sfx_enaaw6" }
	},
	flo = {
		victory = { "sfx_floow2", "sfx_floow3", "sfx_floow4" }
	},
	marauder = {
		victory = { "sfx_mardw2", "sfx_mardw3" }
	},
	mrmonopoly = {
		victory = { "sfx_mnpyw2", "sfx_mnpyw3", "sfx_mnpyw4", "sfx_mnpyw5", "sfx_mnpyw6", "sfx_mnpyw7" }
	},
	venture = {
		victory = { "sfx_ventw2", "sfx_ventw3", "sfx_ventw4", "sfx_ventw5" }
	},
	zim = {
		victory = { "sfx_zimmw2", "sfx_zimmw3", "sfx_zimmw4", "sfx_zimmw5", "sfx_zimmw6", "sfx_zimmw7" }
	},
	zooble = {
		victory = { "sfx_zoobw2", "sfx_zoobw3", "sfx_zoobw4", "sfx_zoobw5" }
	},
	jax = {
		victory = { "sfx_jaxxw2", "sfx_jaxxw3", "sfx_jaxxw4", "sfx_jaxxw5", "sfx_jaxxw6" }
	},
	pomni = {
		victory = { "sfx_pomiw2", "sfx_pomiw3", "sfx_pomiw4", "sfx_pomiw5", "sfx_pomiw6" }
	},
}

local pypak_morevoices = CV_RegisterVar({
	name = "pypak_morevoices",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff,
	description = "Enable this to hear additional voicelines for PyPak characters!"
})

local pypak_debugmode = CV_RegisterVar({
	name = "pypak_debugmode",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CHEAT,
	possiblevalue = CV_OnOff,
	description = "Prints sinister debugging technobabble to the console."
})

local function PyPak_IsPlayerValid (plr)
	if not ( plr and plr.valid ) then return false end
	if plr.spectator then return false end
	if not ( plr.mo and plr.mo.valid ) then return false end
	return true
end

for char, info in pairs(pypak.voices) do
	print("[PyPak] Found sound info for "..char..". Registering...")
	for category, sndlist in pairs(info) do
		for _, snd in ipairs(sndlist) do
			freeslot(snd)
		end
	end
end

print("[PyPak] PyPak Lua ENGAGED!!!")

addHook("PlayerThink", function(p)
	if not pypak_morevoices then return end
	
    if not PyPak_IsPlayerValid(p) then return end
	
	if not pypak.voices[p.mo.skin] then return end
	
	if p.exiting == 0 then
		p.py_playedRank = false
		return
	end
	
	if not p.py_playedRank and p.exiting > 0 then
		if S_IdPlaying(skins[p.mo.skin].soundsid[SKSKWIN]) then
			local playValue = (leveltime) % (#pypak.voices[p.mo.skin]["victory"]+1)
			if playValue > 0 then -- include og sound
				S_StopSoundByID(nil, skins[p.mo.skin].soundsid[SKSKWIN])
				S_StartSound(nil, _G[pypak.voices[p.mo.skin]["victory"][playValue]])
			end
			p.py_playedRank = true
			if pypak_debugmode.value then
				print("Intercepting rank sound, playing "..tostring(playValue))
			end
		end
	end
end)